//+------------------------------------------------------------------+
//|                                      Heiken Ashi Ma Smoothed.mq4 |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//|                                               2009 mod by mladen |
//|                                              tools made it lines |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,Forex-TSD.com"
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  RoyalBlue
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    MaPeriod        = 5;
extern int    MaMetod         = 2;
extern int    Step            = 1;
extern bool   BetterFormula   = true;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);   
   SetIndexBuffer(0, Buffer3); 
   SetIndexBuffer(1, Buffer4);      
   SetIndexBuffer(2, Buffer1); 
   SetIndexBuffer(3, Buffer2); 
   SetIndexBuffer(4, trend);
   
   //
   //
   //
   //
   //
      
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   double pointModifier;
   int    pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { Buffer3[0] = limit+1; return(0); }
         if (Digits==3 || Digits==5)
               pointModifier = 10;
         else  pointModifier = 1;               
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {          
     for(pos=limit; pos >= 0; pos--)
     {
        double maOpen  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN ,pos);
        double maClose = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
        double maLow   = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW  ,pos);
        double maHigh  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH ,pos);
      
        //
        //
        //
        //
        //
        
        if (BetterFormula) {
           if (maHigh!=maLow)
              double haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
           else      haClose = (maOpen+maClose)/2; }
           else      haClose = (maOpen+maHigh+maLow+maClose)/4;
              double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
              double haHigh  = MathMax(maHigh, MathMax(haOpen,haClose));
              double haLow   = MathMin(maLow,  MathMin(haOpen,haClose));

        if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
        else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                              Buffer3[pos]=haOpen;
                              Buffer4[pos]=haClose;
      
       //
       //
       //
       //
       //

       if (Step>0)
       {
         if(MathAbs(Buffer1[pos]-Buffer1[pos+1]) < Step*pointModifier*Point) Buffer1[pos]=Buffer1[pos+1];
         if(MathAbs(Buffer2[pos]-Buffer2[pos+1]) < Step*pointModifier*Point) Buffer2[pos]=Buffer2[pos+1];
         if(MathAbs(Buffer3[pos]-Buffer3[pos+1]) < Step*pointModifier*Point) Buffer3[pos]=Buffer3[pos+1];
         if(MathAbs(Buffer4[pos]-Buffer4[pos+1]) < Step*pointModifier*Point) Buffer4[pos]=Buffer4[pos+1];
       }         
       trend[pos] = trend[pos+1];
          if (Buffer3[pos] < Buffer4[pos]) trend[pos] =  1;
          if (Buffer3[pos] > Buffer4[pos]) trend[pos] = -1;    
    }   
    manageAlerts();
    return(0);
    }
    
    //
    //
    //
    //
    //
   
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    for(pos = limit; pos >= 0; pos--)
    {
     int y = iBarShift(NULL,timeFrame,Time[pos]);
        Buffer3[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMetod,Step,BetterFormula,0,y);
        Buffer4[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMetod,Step,BetterFormula,1,y);
        trend[pos]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaMetod,Step,BetterFormula,4,y);
    }   
    manageAlerts();
 return(0);
 }
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Heiken Ashi Smoothed Lines  ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi Smoothed Lines "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}



